using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Configurations;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IDiscountBranchDetailConfigRepository
    {
        Task<BaseResult> Add(DiscountBranchDetailConfigElastic DiscountBranchDetailConfig);

        Task<BaseResult> AddManyAsync(IEnumerable<DiscountBranchDetailConfigElastic> DiscountBranchDetailConfigs);

        Task<SmartTableResult<DiscountBranchDetailConfigElastic>> Search(BoolQueryDescriptor<DiscountBranchDetailConfigElastic> query);

        Task<ISearchResponse<DiscountBranchDetailConfigElastic>> SearchAgg(BoolQueryDescriptor<DiscountBranchDetailConfigElastic> query, AggregationContainerDescriptor<DiscountBranchDetailConfigElastic> aggs);

        Task<SmartTableResult<DiscountBranchDetailConfigElastic>> Search(BoolQueryDescriptor<DiscountBranchDetailConfigElastic> query, int count);
    }

    public class DiscountBranchDetailConfigRepository : IDiscountBranchDetailConfigRepository
    {
        private readonly ElasticIndex<DiscountBranchDetailConfigElastic> _dbContext;

        public DiscountBranchDetailConfigRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<DiscountBranchDetailConfigElastic>(settings.Value.ClusterUrl, "inventorydiscountbranchdetailconfig");
        }

        public async Task<SmartTableResult<DiscountBranchDetailConfigElastic>> Search(BoolQueryDescriptor<DiscountBranchDetailConfigElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<BaseResult> Add(DiscountBranchDetailConfigElastic DiscountBranchDetailConfig)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(DiscountBranchDetailConfig);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<DiscountBranchDetailConfigElastic> DiscountBranchDetailConfigs)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(DiscountBranchDetailConfigs);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<ISearchResponse<DiscountBranchDetailConfigElastic>> SearchAgg(BoolQueryDescriptor<DiscountBranchDetailConfigElastic> query, AggregationContainerDescriptor<DiscountBranchDetailConfigElastic> aggs)
        {
            return await _dbContext.SearchAgg(query, aggs);
        }

        public async Task<SmartTableResult<DiscountBranchDetailConfigElastic>> Search(BoolQueryDescriptor<DiscountBranchDetailConfigElastic> query, int count)
        {
            return await _dbContext.Search(query, count);
        }
    }
}